Summary: BMS Menu/Shell system for EDX
Name: edx-ms
Version: 0.3
Release: 2%{?dist}
License: Proprietary
Group: Applications/System
Source: %{name}-%{version}.tar.gz
BuildRoot: /var/tmp/%{name}-buildroot
Vendor: Stuart D. Gathman <stuart@bmsi.com>
Packager: Stuart D. Gathman <stuart@bmsi.com>
BuildArch: noarch
# edx-1.1.14 renames $btree to btree2
Requires: edx >= 1.1.13
BuildRequires: python >= 2.3
BuildRequires: edx, edx-devel >= 1.1.14, edx-asm, edx-copycd, bmsi-edx

%description
Provides a stackable overlay system which allows an EDX application to
be swapped out while calling a subprogram and swapped back in on return.
This creates a primitive but effective form of virtual memory,  so that 
typically only 32 K EDX memory per user is required for arbitrary nesting
levels.

Also provides a simple database driven menu and application level security
framework for EDX applications.

%package -n edx-ms-devel
Summary: Copycodes and libraries for BMS Menu System
Group: Development/Libraries

%description -n edx-ms-devel
Provides EDL copycodes (file layouts) and link edit subroutines
for BMS Menu System.  Install this if you need to develop EDL code
that interfaces with the BMS Menu System.

%prep
%setup -q

%build
umask 002
chmod g+w .
mkdir objs
make subs
mv *.edx objs
make all

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/bms/edx/mslib
mkdir -p $RPM_BUILD_ROOT/bms/edx/objlib
mkdir -p $RPM_BUILD_ROOT/bms/edx/copycd
mkdir -p $RPM_BUILD_ROOT/bms/edx/edx002
mkdir -p $RPM_BUILD_ROOT/bms/edx/scrns/util
MSLIB="$RPM_BUILD_ROOT/bms/edx/mslib"
cp -p *.edx $MSLIB
cp -p objs/*.edx $RPM_BUILD_ROOT/bms/edx/objlib
cp -p *.f $RPM_BUILD_ROOT/bms/edx/copycd
cp -p scrns/*.scr $RPM_BUILD_ROOT/bms/edx/scrns/util
python ss.py -o"$MSLIB/#msmain.edx" -p'MSLOG,##' msmain.edx msopen.edx
python ss.py -o"$MSLIB/#msmains.edx" -p'DUMMY,##' -p'%MAINS,%BTGL' \
	msmain.edx msopen.edx
mv $MSLIB/init.edx $RPM_BUILD_ROOT/bms/edx/edx002/\$initial.edx

# install convenience scripts
mkdir -p $RPM_BUILD_ROOT%{_libexecdir}/edx
for i in *.sh; do
  cp -p $i $RPM_BUILD_ROOT%{_libexecdir}/edx/${i%.sh}
  chmod a+x $RPM_BUILD_ROOT%{_libexecdir}/edx/${i%.sh}
done

# link commonly used ones

mkdir $RPM_BUILD_ROOT%{_bindir}
for i in lkmenu; do
  ln -sf %{_libexecdir}/edx/$i $RPM_BUILD_ROOT%{_bindir}
done

%files
%defattr(0664,bin,bms,0775)
/bms/edx/mslib/*
/bms/edx/scrns
/bms/edx/edx002/*
%{_libexecdir}/edx/*
%{_bindir}/*

%files -n edx-ms-devel
%defattr(0664,bin,bms,0775)
/bms/edx/objlib/*
/bms/edx/copycd/*

%post
cd /bms/edx/mslib
test -s \$btree.edx && test ! -e btree2.edx && cp -p \$btree.edx btree2.edx

%changelog
* Thu Aug 30 2018 Stuart Gathman <stuart@gathman.org> 0.3-2
- Move scripts to /usr/libexec/edx

* Sat Aug 25 2018 Stuart Gathman <stuart@gathman.org> 0.3-1
- Take ownership of copycd belonging to mssr programs

* Fri Apr  7 2017 Stuart Gathman <stuart@gathman.org> 0.2-4
- Let edx also own /bms/edx/mslib

* Mon Oct 11 2010 Stuart Gathman <stuart@bmsi.com> 0.2-3
- Copy $BTREE -> BTREE2 if edx < 1.1.14 installed

* Mon Oct 11 2010 Stuart Gathman <stuart@bmsi.com> 0.2-2
- Require only edx-1.1.13

* Fri Oct  1 2010 Stuart Gathman <stuart@bmsi.com> 0.2-1
- Include utility scripts
- Include missing subs and programs, updated bteriq

* Fri Sep 24 2010 Stuart Gathman <stuart@bmsi.com> 0.1-2
- Move screens to scrns/util
- Wait for Edxjava before loading terminals
